---
title: Xamarin.Android error XA0035
description: XA0035 error code
ms.date: 06/17/2020
---
# Xamarin.Android error XA0035

## Issue

Xamarin.Android was not able to determine the application's target
[Android ABIs][abis] as specified by the `.csproj` file.

[abis]: https://developer.android.com/ndk/guides/abis

## Solution

Open the project file [in Visual Studio][edit-project-files] or another text
editor and make sure all of the values in the `RuntimeIdentifiers` MSBuild
property are valid:

```xml
<PropertyGroup>
  <RuntimeIdentifiers>android-arm;android-arm64;android-x86;android-x64</RuntimeIdentifiers>
</PropertyGroup>
```

See the Microsoft documentation on [runtime identifiers][rids] for more
information.

[edit-project-files]: https://docs.microsoft.com/visualstudio/msbuild/visual-studio-integration-msbuild#edit-project-files-in-visual-studio
[rids]: https://docs.microsoft.com/dotnet/core/rid-catalog

## Example messages

```
error XA0035: Unable to determine the Android ABI from the value 'XYZ'. Edit the project file in a text editor and set the 'RuntimeIdentifiers' MSBuild property to contain only valid identifiers for the Android platform.
```
