.PHONY: leeroy jenkins leeroy-all
.PHONY: create-vsix

#
# framework-assemblies lives in bin/Build$(CONFIGURATION)/rules.mk generated by `make prepare`
#
# It has to be invoked with $(MAKE) because otherwise rules.mk would not be included and we'd
# get a build failure.
#
# The other targets depended upon by leeroy also require rules.mk to be present and thus they
# are invoked in the same way framework-assemblies is
#
# Local `make jenkins` invocations should build everything by default. We need to ensure `-a` is passed to xaprepare when no CI flags are set.
#
jenkins:
ifeq ($(PREPARE_CI_PR)$(PREPARE_CI),00)
	$(MAKE) PREPARE_ARGS=-a prepare
else
	$(MAKE) prepare
endif
ifneq ("$(wildcard $(topdir)/external/monodroid/Makefile)","")
	cd $(topdir)/external/monodroid && ./configure --with-xamarin-android='$(topdir)'
	$(call SYSTEM_DOTNET_BINLOG,build-commercial) $(SOLUTION) -t:BuildExternal --no-restore
endif
	$(MAKE) leeroy

leeroy: leeroy-all framework-assemblies

leeroy-all:
	$(call DOTNET_BINLOG,leeroy-all) $(SOLUTION) $(_MSBUILD_ARGS)
	$(call DOTNET_BINLOG,setup-workload) -t:ConfigureLocalWorkload build-tools/create-packs/Microsoft.Android.Sdk.proj
	$(call MSBUILD_BINLOG,leeroy-all,$(_SLN_BUILD)) /restore tools/xabuild/xabuild.csproj /p:Configuration=$(CONFIGURATION) $(_MSBUILD_ARGS)
